#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <iomanip>


using namespace std;

struct Adatsor {
	int ora, perc, azon;
	string ir;
	int ido;
	int lsz;
};

int main()
{
	ifstream fin;
	fin.open("ajto.txt");
	vector<Adatsor> adatok;
	Adatsor akt;
	while(fin >> akt.ora) {
		fin >> akt.perc >> akt.azon >> akt.ir;
		akt.ido = akt.ora*60 + akt.perc;
		akt.lsz += (akt.ir == "be")? 1:-1;
		adatok.push_back(akt);
	}

	fin.close();

	cout<< "2. feladat" << endl;
	cout << "Az elso belepo: " << adatok[0].azon << endl;
	int it;
	for(it = adatok.size() - 1; it >= 0 && adatok[it].ir != "ki"; --it)
		;
	cout << "Az utolso kilepo: " << adatok[it].azon << endl;

	ofstream fout;
	map<int, int> atlep;
	for(auto a:adatok)
		atlep[a.azon] +=1;
	fout.open("athaladas.txt");
	for(auto a : atlep)
		fout << a.first << " " << a.second << endl;
	fout.close();
	cout<< "4. feladat" << endl;
	cout << "A vegen a tarsalgoban voltak:";
	for(auto a : atlep)
		if(a.second %2 == 1)
			cout << " " << a.first;
	cout << endl;

	cout<< "5. feladat" << endl;

	int leg = 0;
	for(size_t i = 0; i < adatok.size(); ++i)
		if(adatok[i].lsz > adatok[leg].lsz)
			leg = i;
	cout << "Peldaul" << adatok[leg].ora << ":" << adatok[leg].perc << "-kor voltak a legtobben"<< endl;

	cout<< "6. feladat" << endl;
	cout << "Adja meg a szemely azonositojat: ";
	int azon;
	cin >> azon;

	cout<< "7. feladat" << endl;
	int kezd = -1;
	int eltolt = 0;
	for(auto a : adatok)
		if(a.azon == azon) {
			cout << setfill('0') << setw(2) << a.ora << ":" << setw(2) << a.perc;
			if (a.ir == "be") {
				kezd = a.ido;
				cout << "-";
			} else {
				cout << endl;
				eltolt += a.ido-kezd;
				kezd = -1;
			}
		}
	if ( kezd != -1) {
		eltolt += 15 * 60-kezd;
		cout << endl;
	}
	cout<< "8. feladat" << endl;
	cout << "Az " << azon << ". szemely osszesen " << eltolt << " percet volt bent, a megfigyeles vegen";
	if(kezd == -1)
		cout << " nem volt a tarsalgoban." << endl;
	else
		cout << " a tarsalgoban volt" << endl;
	return 0;
}
